zoukankan      html  css  js  c++  java
  • POJ 3216 Prime Path (BFS)

    The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
    — It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
    — But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
    — I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
    — No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
    — I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
    — Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

    Now, the minister of finance, who had been eavesdropping, intervened. 
    — No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
    — Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
    — In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
    1033 
    1733 
    3733 
    3739 
    3779 
    8779 
    8179
    The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

    Input

    One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

    Output

    One line for each case, either with a number stating the minimal cost or containing the word Impossible.

    Sample Input

    3
    1033 8179
    1373 8017
    1033 1033

    Sample Output

    6
    7
    0
    题意:
      每一步只能更改其中的一个数字,并且更改后的数字必须是素数,问最短需要多少步可以变成需要的数字。
    题解:
      求这种最短路一般都用BFS。代码稍微复杂了点。可以打张素数表,可以节省时间。
    #include<iostream>
    #include<queue>
    #include<cstring>
    using namespace std;
    const int maxn=1e4+5;
    bool isp[maxn],vis[maxn];
    int n,m;
    struct node
    {
        int a[4],step;
    };
    bool is_prime(int n)
    {
        for(int i=2;i*i<=n;i++)
        {
            if(n%i==0)
                return false;
        }
        return true;
    }
    int bfs(int n)
    {
        node now;
        now.a[0]=n/1000;
        now.a[1]=n/100%10;
        now.a[2]=n/10%10;
        now.a[3]=n%10;
        now.step=0;
        queue<node>que;
        que.push(now);
        while(que.size())
        {
            now=que.front();
            que.pop();
            node next;
            if(now.a[0]==m/1000&&now.a[1]==m/100%10&&now.a[2]==m/10%10&&now.a[3]==m%10)
                return now.step;
            for(int i=0;i<4;i++)
            {
                for(int j=0;j<10;j++)
                {
                    next=now;
                    if(i||j)
                        next.a[i]=j;
                    else
                        continue;
                    int sum=next.a[0];
                    for(int k=1;k<4;k++)
                        sum=sum*10+next.a[k];
                    if(!vis[sum]&&isp[sum])
                    {
                        vis[sum]=true;
                        next.step++;
                        que.push(next);
                    }
                }
            }
        }
        return -1;
    }
    int main()
    {
        for(int i=1000;i<10000;i++)
            isp[i]=is_prime(i);//打素数表
        int t;
        cin>>t;
        while(t--)
        {
            memset(vis,false,sizeof(vis));
            cin>>n>>m;
            vis[n]=true;
            cout<<bfs(n)<<endl;
        }
        return 0;
    }
     
  • 相关阅读:
    PHP之Trait详解
    PHP中__call()方法与重载解析
    PHP Closure(闭包)类详解
    PHP 核心特性
    回调函数
    php的各种 I/O流 以及用法
    关于php的buffer(缓冲区)
    php的运行原理、cgi对比fastcgi以及php-cgi和php-fpm之间的联系区别
    低功耗设计入门(一)——低功耗设计目的与功耗的类型
    从CMOS到触发器(一)
  • 原文地址:https://www.cnblogs.com/orion7/p/7307775.html
Copyright © 2011-2022 走看看